#include <bits/stdc++.h>
using namespace std;
long long a[75005],b[75005],c,mx,n,m,raz,t,r,rb,res,gg;
int main () {
    cin>>t;
    while(t--){
        raz=10e18+1;
        gg=0;
        cin>>n>>m;
        for(int i=1;i<=n;i++){
           cin>>a[i];
        }
        for(int i=1;i<=m;i++){
            cin>>b[i];
        }
        for(int i=2;i<=n;i++){
            r=abs(a[i]-a[i-1]);
            raz=min(r,raz);
        }
        for(int i=2;i<=m;i++){
            rb=abs(b[i]-b[i-1]);
            if((rb%raz)==0){res=-1; break;}
            else res=1;
        }
        if(res==1)cout<<1<<endl;
        else cout<<0<<endl;
    }
    return 0;
}